/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import BN from "bn.js";
import { ContractOptions } from "web3-eth-contract";
import { EventLog } from "web3-core";
import { EventEmitter } from "events";
import {
  Callback,
  PayableTransactionObject,
  NonPayableTransactionObject,
  BlockType,
  ContractEventLog,
  BaseContract,
} from "./types";

interface EventOptions {
  filter?: object;
  fromBlock?: BlockType;
  topics?: string[];
}

export type Paused = ContractEventLog<{
  account: string;
  0: string;
}>;
export type Unpaused = ContractEventLog<{
  account: string;
  0: string;
}>;
export type PauserAdded = ContractEventLog<{
  account: string;
  0: string;
}>;
export type PauserRemoved = ContractEventLog<{
  account: string;
  0: string;
}>;

export interface Pausable extends BaseContract {
  constructor(
    jsonInterface: any[],
    address?: string,
    options?: ContractOptions
  ): Pausable;
  clone(): Pausable;
  methods: {
    isPauser(account: string): NonPayableTransactionObject<boolean>;

    renouncePauser(): NonPayableTransactionObject<void>;

    addPauser(account: string): NonPayableTransactionObject<void>;

    /**
     * @returns true if the contract is paused, false otherwise.
     */
    paused(): NonPayableTransactionObject<boolean>;

    /**
     * called by the owner to pause, triggers stopped state
     */
    pause(): NonPayableTransactionObject<void>;

    /**
     * called by the owner to unpause, returns to normal state
     */
    unpause(): NonPayableTransactionObject<void>;
  };
  events: {
    Paused(cb?: Callback<Paused>): EventEmitter;
    Paused(options?: EventOptions, cb?: Callback<Paused>): EventEmitter;

    Unpaused(cb?: Callback<Unpaused>): EventEmitter;
    Unpaused(options?: EventOptions, cb?: Callback<Unpaused>): EventEmitter;

    PauserAdded(cb?: Callback<PauserAdded>): EventEmitter;
    PauserAdded(
      options?: EventOptions,
      cb?: Callback<PauserAdded>
    ): EventEmitter;

    PauserRemoved(cb?: Callback<PauserRemoved>): EventEmitter;
    PauserRemoved(
      options?: EventOptions,
      cb?: Callback<PauserRemoved>
    ): EventEmitter;

    allEvents(options?: EventOptions, cb?: Callback<EventLog>): EventEmitter;
  };

  once(event: "Paused", cb: Callback<Paused>): void;
  once(event: "Paused", options: EventOptions, cb: Callback<Paused>): void;

  once(event: "Unpaused", cb: Callback<Unpaused>): void;
  once(event: "Unpaused", options: EventOptions, cb: Callback<Unpaused>): void;

  once(event: "PauserAdded", cb: Callback<PauserAdded>): void;
  once(
    event: "PauserAdded",
    options: EventOptions,
    cb: Callback<PauserAdded>
  ): void;

  once(event: "PauserRemoved", cb: Callback<PauserRemoved>): void;
  once(
    event: "PauserRemoved",
    options: EventOptions,
    cb: Callback<PauserRemoved>
  ): void;
}
